﻿#include <stdlib.h> //exit()
#include "sysfs_gpio.h"
#include <fcntl.h>
#include <signal.h> //signal()
#include <stdint.h>
#include <unistd.h>

void DEV_Delay_ms(uint32_t xms) {
  uint32_t i;
  for (i = 0; i < xms; i++) {
    usleep(1000);
  }
}

void DEV_GPIO_Mode(uint16_t Pin, uint16_t Mode) {
  SYSFS_GPIO_Export(Pin);
  SYSFS_GPIO_Direction(Pin, Mode);
}

void Handler(int signo) {
  // System Exit
  printf("\r\nHandler:exit\r\n");
  exit(0);
}

int main(void) {
  // Exception handling:ctrl + c
  signal(SIGINT, Handler);
  int x[25] = {GPIO7,    UART2_TX, UART2_RX, GPIO11,    GPIO12,    GPIO13,
               GPIO15,   GPIO16,   GPIO18,   SPI1_MOSI, SPI1_MISO, GPIO22,
               SPI1_CLK, SPI1_CS0, SPI1_CS1, GPIO29,    GPIO31,    GPIO32,
               GPIO33,   GPIO35,   GPIO36,   GPIO37,    GPIO38,    GPIO40};

  int i = 0;
  while (1) {
    // printf("1\r\n");
    DEV_GPIO_Mode(x[i], 1);
    SYSFS_GPIO_Write(x[i], 0);
    DEV_Delay_ms(500);
    // printf("0\r\n");
    SYSFS_GPIO_Write(x[i], 1);
    DEV_Delay_ms(500);
    SYSFS_GPIO_Write(x[i], 0);
    DEV_Delay_ms(500);
    i++;
    if (i > 23)
      i = 0;
  }

  return 0;
}
