/*****************************************************************************
* | File        :   sysfs_gpio.h
* | Author      :   Luckfox team
* | Function    :   Drive SC16IS752 GPIO
* | Info        :   Read and write /sys/class/gpio
*----------------
* |	This version:   V2.0
* | Date        :   2023-06-26
* | Info        :   Basic version
*
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documnetation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to  whom the Software is
# furished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS OR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.
#
******************************************************************************/
#ifndef __SYSFS_GPIO_DEBIAN_
#define __SYSFS_GPIO_DEBIAN_

#include <stdio.h>

#define IN 0
#define OUT 1

#define LOW 0
#define HIGH 1

#define NUM_MAXBUF 4
#define DIR_MAXSIZ 60

#define SYSFS_GPIO_DEBUG 1
#if SYSFS_GPIO_DEBUG
#define SYSFS_GPIO_Debug(__info, ...) printf("Debug: " __info, ##__VA_ARGS__)
#else
#define SYSFS_GPIO_Debug(__info, ...)
#endif

// 22PIN + 2PIN UART0 + 2PIN I2C0 + 2PIN I2C
// + 2PIN 3V3 + 2PIN 5V + 8PIN GND  = 40PIN
/*******************/

#define GPIO7 111     // 7,111
#define UART2_TX 25   // 8,25
#define UART2_RX 24   // 10,24
#define GPIO11 104    // 11,104
#define GPIO12 150    // 12,150
#define GPIO13 116    // 13,116
#define GPIO15 117    // 15,117
#define GPIO16 97     // 16,97
#define GPIO18 98     // 18,98
#define SPI1_MOSI 113 // 19,113
#define SPI1_MISO 114 // 21,114
#define GPIO22 99     // 22,99
#define SPI1_CLK 115  // 23,115
#define SPI1_CS0 100  // 24,100
#define SPI1_CS1 101  // 26,101
#define GPIO29 112    // 29,112
#define GPIO31 148    // 31,148
#define GPIO32 106    // 32,106
#define GPIO33 105    // 33,105
#define GPIO35 149    // 35,149
#define GPIO36 102    // 36,102
#define GPIO37 103    // 37,103
#define GPIO38 147    // 38,147
#define GPIO40 146    // 40,146

int SYSFS_GPIO_Export(int Pin);
int SYSFS_GPIO_Unexport(int Pin);
int SYSFS_GPIO_Direction(int Pin, int Dir);
int SYSFS_GPIO_Read(int Pin);
int SYSFS_GPIO_Write(int Pin, int value);

#endif
